@if not exist echo echo off
rem usage: PWAVRLD project [-lpt N]

if not X%1 == X goto parm_ok1
echo please supply project file name as first parameter!
echo usage: PWAVRLD project [-lpt N]
goto abort
:parm_ok1

if exist %1.rom goto parm_ok2
echo can't find PicoWeb ROM file %1.rom!
goto abort
:parm_ok2

if not X%PWDEV% == X goto env_ok
echo environment variable PWDEV not set!
goto oops
:env_ok

if exist %PWDEV%\bin\nul goto path_ok
echo can't find PicoWeb binary directory %PWDEV%\bin!
goto oops
:path_ok

if exist %PWDEV%\bin\avr.exe goto got_avr
echo Can't find program %PWDEV%\bin\avr.exe!
goto abort
:got_avr

if not exist %1.rom goto abort
echo Loading PicoWeb program memory with '%1.rom'
echo error > %1.bad
if X%remote% == X goto load_local

copy %1.rom %remote%
set eeload=
if not exist %1.ep goto no_ep_remote
copy %1.ep %remote%
set eeload=-le %1.ep

:no_ep_remote
echo.avr -ce -lp %1.rom %eeload% -en >%remote%\work.bat
:wait
if not exist %remote%\work.bat goto load_complete
%PWDEV%\bin\perl -e "sleep 2"
goto wait

:load_local
echo Reading PicoWeb's current firmware
if exist %1.crm del %1.crm
if exist %1.cee del %1.cee
%PWDEV%\bin\avr %2 %3 %4 -sp %1.crm -se %1.cee
if errorlevel 1 goto hint1

%PWDEV%\bin\perl %PWDEV%\bin\avrdiff.pl %1.crm %1.rom
if errorlevel 10 goto skip_rom_load

echo %PWDEV%\bin\avr %2 %3 %4 -ce -lp %1.rom
%PWDEV%\bin\avr %2 %3 %4 -ce -lp %1.rom
if errorlevel 1 goto abort
if exist %1.cee del %1.cee
:skip_rom_load

if not exist %1.ep goto no_ep
if not exist %1.cee goto load_ee
%PWDEV%\bin\perl %PWDEV%\bin\avrdiff.pl %1.cee %1.ep
if errorlevel 10 goto no_ep

:load_ee
echo Loading PicoWeb EEPROM memory with '%1.ep'
echo %PWDEV%\bin\avr %2 %3 %4 -le %1.ep
%PWDEV%\bin\avr %2 %3 %4 -le %1.ep
if errorlevel 1 goto abort
:no_ep

if exist %PWDEV%\lib\breadboard goto skip_en
echo Enabling PicoWeb server
%PWDEV%\bin\avr %2 %3 %4 -en
if errorlevel 1 goto abort
:skip_en

:load_complete
echo PicoWeb AVR firmware load complete.
%PWDEV%\bin\perl -e "sleep 1"
if exist %1.crm del %1.crm
if exist %1.cee del %1.cee
if exist %1.bad del %1.bad
if not exist %PWDEV%\lib\breadboard goto done

echo -------------------------------------------------------------------------
echo  Warning: PicoWeb breadboard RESET active!!
echo           Remove programming cable (or use "avr -en") to clear.
echo -------------------------------------------------------------------------
goto done

:hint1
echo -------------------------------------------------------------------------
echo  Hint: Verify PicoWeb programming cable is attached and unit is powered.
echo -------------------------------------------------------------------------

:abort
echo Aborted PicoWeb AVR firmware load!
:done
