@if not exist echo echo off
rem usage: PWBUILD project [clean]

if not X%1 == X goto parm_ok1
echo please supply project file name as first parameter!
echo usage: PWBUILD project [clean]
goto oops
:parm_ok1

if X%2 == Xclean goto clean
if X%2 == Xlink goto link

if exist %1.pwp goto parm_ok2
echo can't find project file %1.pwp!
goto oops
:parm_ok2

if not X%PWDEV% == X goto env_ok
echo environment variable PWDEV not set!
goto oops
:env_ok

if exist %PWDEV%\bin\nul goto path_ok
echo can't find PicoWeb binary directory %PWDEV%\bin!
goto oops
:path_ok

:clean
echo deleting output files
if exist %1.rom del %1.rom
if exist %1.ep del %1.ep
if exist %1.el del %1.el
if exist %1.cmd del %1.cmd
if exist %1.asm del %1.asm
if exist %1.h del %1.h
if exist %1.o del %1.o
if exist %1.s del %1.s
if exist %1.lst del %1.lst
if exist %1.map del %1.map
if exist %1.sym del %1.sym
if exist %1.elf del %1.elf
if exist %1.rm1 del %1.rm1
if exist %1.rm2 del %1.rm2

if exist %1.ld del %1.ld
if exist %1.ldi del %1.ldi
if exist %1.lds del %1.lds

if exist %1.i del %1.i
if exist %1.is del %1.is
if exist %1.asi del %1.asi
if exist %1.pi del %1.pi
if exist %1.def del %1.def

if exist ip.inc del ip.inc
if exist ether.inc del ether.inc
if exist gw.inc del gw.inc

rem old stype files...
if exist userasm.asm del userasm.asm
if exist userfid.asm del userfid.asm
if exist userrst.asm del userrst.asm
if exist usersid.asm del usersid.asm
if exist userdef.h   del userdef.h
if exist cmd.inc del cmd.inc
if exist %1.imp del %1.imp
if exist %1.dat del %1.dat
if exist %1.eep del %1.eep

if X%2 == Xclean goto done

echo.setting IP address
if exist ip goto ip_ok
echo can't find IP address definition file 'ip'!
goto oops
:ip_ok
%PWDEV%\bin\perl %PWDEV%\bin\ip2hex.pl -v - <ip >ip.inc
if errorlevel 1 goto oops

echo.setting gateway IP address
if exist gw goto gw_ok
if not X%PW_GW% == X goto gw_ok
if exist gw goto gw_ok
echo 	.word   0x0000 ; default gateway > gw.inc 
echo 	.word   0x0000 >> gw.inc 
echo 	.word   0x0000 ; default gateway netmask >> gw.inc 
echo 	.word   0x0000 >> gw.inc 
goto gw_done
:gw_ok
%PWDEV%\bin\perl %PWDEV%\bin\ip2hex.pl -v -gw - <gw >gw.inc
if errorlevel 1 goto oops
:gw_done

echo.setting Ethernet address
if exist ether goto mac_ok
echo can't find Ethernet address definition file 'ether'!
goto oops
:mac_ok
%PWDEV%\bin\perl %PWDEV%\bin\mac2hex.pl -v - <ether >ether.inc
if errorlevel 1 goto oops

echo.making command table.
if not exist cmd.txt goto no_cmd_txt
%PWDEV%\bin\perl %PWDEV%\bin\cmd2asm.pl cmd.txt >%1.cmd
goto cmd_txt
:no_cmd_txt
%PWDEV%\bin\perl %PWDEV%\bin\cmd2asm.pl %PWDEV%\lib\cmd.txt >%1.cmd
:cmd_txt
if errorlevel 1 goto oops

echo.processing project file %1.pwp
%PWDEV%\bin\perl %PWDEV%\bin\pwproj2.pl -v %PWDEV%\lib\version.h %1.pwp %1.h %1
if errorlevel 1 goto oops

call %PWDEV%\bin\gas %1
if errorlevel 1 goto oops

:link
echo.linking project %1.elf
%PWDEV%\bin\cpp -I . -I %PWDEV%/lib %1.ld -o %1.ldi
if errorlevel 1 goto oops

%PWDEV%\bin\perl -ane "s/^(#[^\n]*)//;s/^\/\/[^\n]*//;next if(/^[\s\r\n]*$/);print;" %1.ldi > %1.lds
if errorlevel 1 goto oops

%PWDEV%\bin\avr-ld -o %1.elf -Map %1.map --library-path %PWDEV%\lib %1.o --script %1.lds
if errorlevel 1 goto oops

%PWDEV%\bin\perl %PWDEV%\bin\map2free.pl %1.map
if errorlevel 1 goto oops

echo.making load files
%PWDEV%\bin\readelf -x 1 %1.elf >%1.rm1
if errorlevel 1 goto oops
%PWDEV%\bin\readelf -x 2 %1.elf >%1.rm2
if errorlevel 1 goto oops
%PWDEV%\bin\cat %1.rm1 %1.rm2 | %PWDEV%\bin\perl %PWDEV%\bin\red2rom.pl >%1.rom
if errorlevel 1 goto oops
if exist %1.rm1 del %1.rm1
if exist %1.rm2 del %1.rm2
%PWDEV%\bin\readelf -x 4 %1.elf | %PWDEV%\bin\perl %PWDEV%\bin\red2ep.pl >%1.ep
if errorlevel 1 goto oops
echo 01ff:ff>>%1.ep
if errorlevel 1 goto oops
%PWDEV%\bin\readelf -x 5 %1.elf | %PWDEV%\bin\perl %PWDEV%\bin\red2el.pl >%1.el
if errorlevel 1 goto oops
%PWDEV%\bin\perl %PWDEV%\bin\map2sym.pl %1.map > %1.sym
if errorlevel 1 goto oops
goto done

:oops
echo aborted!
goto finis

:done
echo.done.
:finis

