open(IN,"<$ARGV[0]") || die "$ARGV[0]: $!" ;
open(OUT,">$ARGV[1]") || die "$ARGV[1]: $!" ;
open(I,"<$ARGV[2]") || die "$ARGV[2]: $!" ;

$tabs = 8 ;
$tabstr = substr("                    ",0,$tabs) ;

while (<I>)  {
    chop ;
    if (/pcode_routine\s+(.*)/i)  {
        $count = $1 ;
        if (/\.equ\s*([^= \t]+)/i)  {
            $name = $1 ;
        }
        elsif (/\s*([^: \t]+)/)  {
            $name = $1 ;
        }
        else  {
            next ;
        }
        if (substr($name,0,1) ne '.')  {
            $pcode{$name} = $count ;
        }
    }
}
close(I) ;
$pcode{"0"} = 0 ;   # massive hack to let .dw 0 -> asm

while (<IN>)  {
    s/\t\t/\t$tabstr/g ;
    s/([^\t]+\t)/&fixtab($1)/eg ;
    ($opc,$op1,$op2) = split(" ",$_,3) ;    # no null first field
    if ($opc eq ".dw" || $opc1 eq ".dw")  {
        &preprocess($_) ;
    }
    else  {
        print OUT ;
    }
}
if (defined %ignored)  {
    print "The following verbs were not processed:\n" ;
    while (($k,$v) = each %ignored)  {
        print " $k" ;
    }
    print "\n" ;
}

sub fixtab  {
    local($x) = @_ ;

    chop $x ;
    $x .= substr("                            ",0,$tabs-(length($x)%$tabs)) ;
}

sub find_comment  {
    local($xx) = @_ ;
    local($a) ;
    local($col) = 0 ;

    $parsed = "" ;
    $a = $s ;
    $s = $xx ;
    while ($s ne "")  {
        $token = &toke ;
        if ($token eq ";")  {
            $col = length($parsed) ;
            last ;
        }
    }
    $s = $a ;
    $col ;
}

sub preprocess  {
    local($s) = @_ ;

    chop $s ;
    if ($s =~ /^\s*([^ :]+:\s*)/)  {
        $label = $1 ;
#        print "Label: $label/" ;
        $s = substr($s,length($label),999) ;
    }
    else  {
#        print "Nolabel " ;
        $label = "" ;
    }
    $comment_column = &find_comment($s) ;
#    if ($comment_column > 0)  {
#        print "$comment_column:\n$s\n" ;
#    }
    $op = &toke ;       # .dw
    $operand = "" ;
    $n_ops = 0 ;
    $XX = "" ;
    $parsed = "" ;      # stuff already parsed
    for (;;)  {
        $token = &toke ;
#        print "$token:" ;
        if ($token eq ',' || $token eq ';' || $token eq "")  {
            $operands[$n_ops++] = $operand ;
            last if ($token ne ',') ;
            $operand = "" ;
        }
        else  {
            $operand .= $token ;
        }
    }
    if ($token eq ';')  {
        $comment = $s ;
    }
    else  {
        $comment = "" ;
    }
#    print "\nOperands:\n" ;
    if ($n_ops == 1 && $operands[0] eq "0")  {
        print OUT "    asm\n" ;
        return ;
    }
    $operands[0] =~ s/\|XX//g ;
    if (!defined $pcode{$operands[0]})  {
        print "Ignored(".$operands[0]."): $_" ;
        $ignored{$operands[0]}++ ;
        print OUT ;
        return ;
    }
    $out = "$label    ".$operands[0] ;
    if ($comment =~ /;(ee)*string\s+([^\s]+)\s+("[^"]+")/)  {
        $e = ($1 eq "ee" ? "e" : "") ;
        $string_name = $2 ;
        $string = $3 ;
        for ($i=1 ; $i<$n_ops ; $i++)  {
            if ($operands[$i] eq $string_name)  {
                $operands[$i] = $e.$string ;
            }
        }
        $comment = "" ;
    }
    for ($i=1 ; $i<$n_ops ; $i++)  {
        $operands[$i] =~ s/SWAP\(WORD\(([^)]+)\)\)/[SWAP($1)]/ ;
        $operands[$i] =~ s/BYTE\(([^)]+)\)/[byte $1]/ ;
        $operands[$i] =~ s/WORD\(([^)]+)\)/[$1]/ ;
        $out .= (($i!=1?",":" ").$operands[$i]) ;
    }
    if ($comment ne "")  {
        if (length($out) < $comment_column)  {
            $out = sprintf("%-${comment_column-1}s",$out).";$comment" ;
        }
        else  {
            $out .=  "    ;$comment" ;
        }
    }
    print OUT $out,"\n" ;
}

sub toke  {
    $x = "" ;
    while ($s ne "")  {
        if ($s =~ /^([^;,'" \t]+)/)  {
            $x = $1 ;
        }
        else  {
            $x = substr($s,0,1) ;
            if ($x eq "\'" || $x eq "\"")  {
                $regex = $x."[^$x]*".$x ;
                if ($s =~ /($regex)/)  {
                    $x = $1 ;
                }
                else  {
                    print "Unterminated string\n" ;
                }
            }
            elsif ($x eq ' ' || $x eq "\t")  {
                if ($s =~ /^([ \t]+)/)  {
                    $x = $1 ;
                    $parsed .= substr($s,0,length($x)) ;
                    $s = substr($s,length($x),999) ;
                    $x = "" ;
                    next ;
                }
            }
        }
        $parsed .= substr($s,0,length($x)) ;
        $s = substr($s,length($x),999) ;
        last ;
    }
##    print "$x:" ;
    $x ;
}
