;+
; **-pandcmp4-pcode compare two buffers in SRAM under bitmask for 4 bytes
;
; inputs:
;   r10 -> buffer1
;   r12 -> buffer2
;   r14 -> buffer3 (bitmask)
;
; outputs:
;   pcode condition codes set appropriately.  the comparison operators
;   other than eq and ne are valid only if the input values are in network
;   byte order.
;-

    .global pandcmp4
pandcmp4:  pcode_routine 3               ; @r10&@r14 vs. @r12&@r14 for 4 bytes
    ldi r16,4
pandcmpn1:
    rcall r10reloc
    rcall r12reloc
    rcall r14reloc
pandcmpn_next:
    ld r0,x+
    ld r1,y+
    ld r2,z+
    and r0,r2
    and r1,r2
    cp r0,r1
    brne pandcmpn_done                         ; mismatch - dont keep going...
    dec r16
    brne pandcmpn_next
pandcmpn_done:
    rjmp set_pcode_flags

