;--------------------------------------------------------------------------
;+
; **-purl2s-get characters from seeprom or receive packet data buffer
;
; purl2s s,addr,n
;
; inputs:
;   s     -> sram address to get byte
;   addr  = seeprom address or offset into receive packet buffer
;   n     = number of bytes to transfer
;
; outputs:
;   flags Z=1 : character found
;         Z=0 : no more characters (use pjumpne no_more)
;   s  : characters placed starting at this sram address
;
; note:
;   if bit 15 of addr is set, then address is seeprom
;-
;--------------------------------------------------------------------------

.cseg
    .global purl2s
purl2s: pcode_routine 3
    rcall r12reloc              ; move r12 to y
    sbrs r12h,7                 ; check high bit of addr, skip if set
    rjmp use_pr2s               ; bit clear...execute pr2s pcode
    rcall _see2s                ; read seeprom bytes
    rjmp ok

use_pr2s:
    movwi x,data_len            ; move datalen to r16
    ld r16l,x+
    ld r16h,x+
    cmpw r16,y                  ; datalen - addr
    breq oops                   ; error if same
    brlo oops                   ; error if addr > datalen
    rcall r2s                   ; execute pcode for "pr2s"
ok:
    sez
    rjmp set_pcode_flags
oops:
    clz
    rjmp set_pcode_flags

